<?php

namespace App\Http\Controllers\Operator;

use DB;
use URL;

use Auth;
use Uuid;
use Alert;
use Crypt;
use App\Models\Kelompok;
use Illuminate\Http\Request;

use App\Models\KelompokDetail;
use App\Http\Controllers\Controller;

class KelompokController extends Controller
{
    public function index()
    {
        return view('backend.operator.kelompok.index')->withTitle('Daftar Kelompok');
    }

    /* AJAX request */
    public function getData(Request $request){

        ## Read value
        $draw = $request->get('draw');
        $start = $request->get("start");
        $rowperpage = $request->get("length"); // Rows display per page

        $columnIndex_arr = $request->get('order');
        $columnName_arr = $request->get('columns');
        $order_arr = $request->get('order');
        $search_arr = $request->get('search');

        $columnIndex = $columnIndex_arr[0]['column']; // Column index
        $columnName = $columnName_arr[$columnIndex]['data']; // Column name
        $columnSortOrder = $order_arr[0]['dir']; // asc or desc
        $searchValue = strtoupper($search_arr['value']); // Search value

        // Total records
        $statementGlobal = " STATUS_HAPUS = '0' ";
        $totalRecords = Kelompok::select('count(1) as allcount')->whereRaw($statementGlobal)->count();
        $statement = " AND (UPPER(NAMA_DOSEN) LIKE '%".$searchValue."%') ";

        $totalRecordswithFilter =   Kelompok::select('count(1) as allcount')
                                    ->whereRaw($statementGlobal.$statement)->count();

        // Fetch records
        $records = Kelompok::orderBy($columnName,$columnSortOrder)
            ->whereRaw($statementGlobal.$statement)
            ->selectRaw('*, ambil_ketua_kelompok(kelompok.kelompok_id) ketua')
            ->skip($start)
            ->take($rowperpage)
            ->get();

        $data_arr = array();
        foreach($records as $record){
            $kelompok_id = $record->kelompok_id;
            $kode = $record->kode;
            $ketua = $record->ketua;
            $ketua = explode('###', $record->ketua);
            $nama_ketua = $ketua[0];
            $nim_ketua = $ketua[1];

            $nama_dosen = $record->nama_dosen;
            $nidn_dosen = $record->nidn_dosen;
            $status = $record->status;

            if($status == '1')
                $keterangan = '<span class="badge bg-success">Disetujui</span>';
            elseif($status == '2')
                $keterangan = '<span class="badge bg-danger">Ditolak</span>';
            else
                $keterangan = '<span class="badge bg-warning">Menunngu Persetujuan</span>';

            $data_arr[] = array(
                "kelompok_id" => $kelompok_id,
                "kode" => $kode,
                "nama_ketua" => $nama_ketua,
                "nim_ketua" => $nim_ketua,
                "nama_dosen" => $nama_dosen,
                "nidn_dosen" => $nidn_dosen,
                "keterangan" => $keterangan,
                "aksi" => '<a class="btn btn-primary btn-sm waves-effect waves-light viewdetails" role="button" data-id="'.Crypt::encrypt($kelompok_id).'"><i class="fas fa-eye"></i></a>'
            );
        }

        $response = array(
            "draw" => intval($draw),
            "iTotalRecords" => $totalRecords,
            "iTotalDisplayRecords" => $totalRecordswithFilter,
            "aaData" => $data_arr
        );

        echo json_encode($response);
        exit;
    }

    public function getDetil(Request $request)
    {
        $reqKelompokId = Crypt::decrypt($request->kelompok_id);
        $kelompok_detil = KelompokDetail::where('kelompok_id', $reqKelompokId)->get();

        $data = '';
        $no = 1;
        foreach ($kelompok_detil as $key => $value) {
            if($value->status_ketua == 1)
                $keterangan = "Ketua";
            else
                $keterangan = "Anggota ".$no?:1-1;
            $data .= "
                            <tr>
                                <td>".$no."</td>
                                <td>".$value->nama."</td>
                                <td>".$value->nim."</td>
                                <td>".$value->fakultas."</td>
                                <td>".$value->prodi."</td>
                                <td>".$keterangan."</td>
                            </tr>
                    ";
            $no++;
        }
        $response['html'] = $data;
        echo json_encode($response);
    }

    public function create()
    {

    }

    public function store(Request $request)
    {

    }

    public function edit($id)
    {

    }

    public function update(Request $request, $id)
    {

    }

    public function destroy($id)
    {

    }
}
